blob: 94e90d77e5c1eb45f0e4d2c3e54260d763087d10 [file] [log] [blame]
Rob Landley16890752005-09-02 00:41:53 +00001# Simple test harness infrastructurei for BusyBox
2#
3# Copyright 2005 by Rob Landley
4#
5# License is GPLv2, see LICENSE in the busybox tarball for full license text.
6
Rob Landley48c61572005-11-07 08:50:53 +00007# This file defines two functions, "testing" and "optionflag"
8
Rob Landley48c61572005-11-07 08:50:53 +00009# The following environment variables may be set to enable optional behavior
10# in "testing":
11# VERBOSE - Print the diff -u of each failed test case.
12# DEBUG - Enable command tracing.
13# SKIP - do not perform this test (this is set by "optionflag")
14#
15# The "testing" function takes five arguments:
Rob Landley16890752005-09-02 00:41:53 +000016# $1) Description to display when running command
Mike Frysinger81834532006-04-01 01:35:52 +000017# $2) Command line arguments to command
18# $3) Expected result (on stdout)
Rob Landley16890752005-09-02 00:41:53 +000019# $4) Data written to file "input"
20# $5) Data written to stdin
21#
22# The exit value of testing is the exit value of the command it ran.
23#
24# The environment variable "FAILCOUNT" contains a cumulative total of the
Rob Landley48c61572005-11-07 08:50:53 +000025# number of failed tests.
Rob Landley16890752005-09-02 00:41:53 +000026
Rob Landley48c61572005-11-07 08:50:53 +000027# The "optional" function is used to skip certain tests, ala:
28# optionflag CONFIG_FEATURE_THINGY
29#
30# The "optional" function checks the environment variable "OPTIONFLAGS",
31# which is either empty (in which case it always clears SKIP) or
32# else contains a colon-separated list of features (in which case the function
33# clears SKIP if the flag was found, or sets it to 1 if the flag was not found).
Rob Landley16890752005-09-02 00:41:53 +000034
35export FAILCOUNT=0
Rob Landley48c61572005-11-07 08:50:53 +000036export SKIP=
Rob Landley16890752005-09-02 00:41:53 +000037
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000038# Helper functions
39
Rob Landleycd82c3c2006-06-15 20:07:57 +000040optional()
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000041{
Rob Landley006fa2d2006-02-16 09:00:57 +000042 option=`echo "$OPTIONFLAGS" | egrep "(^|:)$1(:|\$)"`
Rob Landley48c61572005-11-07 08:50:53 +000043 # Not set?
Rob Landley006fa2d2006-02-16 09:00:57 +000044 if [ -z "$1" ] || [ -z "$OPTIONFLAGS" ] || [ ${#option} -ne 0 ]
Rob Landley48c61572005-11-07 08:50:53 +000045 then
46 SKIP=""
47 return
48 fi
49 SKIP=1
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000050}
51
Rob Landley16890752005-09-02 00:41:53 +000052# The testing function
53
Denis Vlasenkocd0df462007-06-05 22:29:14 +000054testing()
Rob Landley16890752005-09-02 00:41:53 +000055{
Rob Landley4bb1b042006-03-16 15:20:45 +000056 NAME="$1"
57 [ -z "$1" ] && NAME=$2
58
Rob Landley16890752005-09-02 00:41:53 +000059 if [ $# -ne 5 ]
60 then
Denis Vlasenko4e1e7202007-11-26 05:38:20 +000061 echo "Test $NAME has wrong number of arguments (must be 5) ($# $*)" >&2
Rob Landley16890752005-09-02 00:41:53 +000062 exit
63 fi
64
Rob Landley4bb1b042006-03-16 15:20:45 +000065 [ -n "$DEBUG" ] && set -x
Mike Frysinger3f91d7a2005-09-24 00:52:58 +000066
Rob Landley48c61572005-11-07 08:50:53 +000067 if [ -n "$SKIP" ]
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000068 then
Rob Landley4bb1b042006-03-16 15:20:45 +000069 echo "SKIPPED: $NAME"
Rob Landley48c61572005-11-07 08:50:53 +000070 return 0
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000071 fi
72
Rob Landley16890752005-09-02 00:41:53 +000073 echo -ne "$3" > expected
74 echo -ne "$4" > input
Rob Landley67d5b8b2006-05-02 21:39:04 +000075 [ -z "$VERBOSE" ] || echo "echo '$5' | $2"
Rob Landley4bb1b042006-03-16 15:20:45 +000076 echo -ne "$5" | eval "$2" > actual
Rob Landley16890752005-09-02 00:41:53 +000077 RETVAL=$?
78
Denis Vlasenko8274e062007-08-06 03:41:08 +000079 cmp expected actual >/dev/null 2>/dev/null
Rob Landleycd82c3c2006-06-15 20:07:57 +000080 if [ $? -ne 0 ]
Rob Landley16890752005-09-02 00:41:53 +000081 then
Rob Landley48c61572005-11-07 08:50:53 +000082 FAILCOUNT=$[$FAILCOUNT+1]
Rob Landley4bb1b042006-03-16 15:20:45 +000083 echo "FAIL: $NAME"
Rob Landleycd82c3c2006-06-15 20:07:57 +000084 [ -n "$VERBOSE" ] && diff -u expected actual
Rob Landley16890752005-09-02 00:41:53 +000085 else
Rob Landley4bb1b042006-03-16 15:20:45 +000086 echo "PASS: $NAME"
Rob Landley16890752005-09-02 00:41:53 +000087 fi
88 rm -f input expected actual
89
Rob Landley4bb1b042006-03-16 15:20:45 +000090 [ -n "$DEBUG" ] && set +x
Mike Frysinger3f91d7a2005-09-24 00:52:58 +000091
Rob Landley16890752005-09-02 00:41:53 +000092 return $RETVAL
93}
Rob Landley3a324752006-03-09 22:04:33 +000094
95# Recursively grab an executable and all the libraries needed to run it.
96# Source paths beginning with / will be copied into destpath, otherwise
97# the file is assumed to already be there and only its library dependencies
98# are copied.
99
Denis Vlasenkocd0df462007-06-05 22:29:14 +0000100mkchroot()
Rob Landley3a324752006-03-09 22:04:33 +0000101{
102 [ $# -lt 2 ] && return
103
Rob Landley4bb1b042006-03-16 15:20:45 +0000104 echo -n .
105
Rob Landley3a324752006-03-09 22:04:33 +0000106 dest=$1
107 shift
108 for i in "$@"
109 do
Rob Landley6bc10632006-03-18 03:01:57 +0000110 [ "${i:0:1}" == "/" ] || i=$(which $i)
111 [ -f "$dest/$i" ] && continue
112 if [ -e "$i" ]
Rob Landley3a324752006-03-09 22:04:33 +0000113 then
Rob Landley3a324752006-03-09 22:04:33 +0000114 d=`echo "$i" | grep -o '.*/'` &&
115 mkdir -p "$dest/$d" &&
116 cat "$i" > "$dest/$i" &&
117 chmod +x "$dest/$i"
Rob Landley6bc10632006-03-18 03:01:57 +0000118 else
119 echo "Not found: $i"
Rob Landley3a324752006-03-09 22:04:33 +0000120 fi
121 mkchroot "$dest" $(ldd "$i" | egrep -o '/.* ')
122 done
123}
Rob Landley4bb1b042006-03-16 15:20:45 +0000124
125# Set up a chroot environment and run commands within it.
126# Needed commands listed on command line
127# Script fed to stdin.
128
Denis Vlasenkocd0df462007-06-05 22:29:14 +0000129dochroot()
Rob Landley4bb1b042006-03-16 15:20:45 +0000130{
131 mkdir tmpdir4chroot
132 mount -t ramfs tmpdir4chroot tmpdir4chroot
133 mkdir -p tmpdir4chroot/{etc,sys,proc,tmp,dev}
134 cp -L testing.sh tmpdir4chroot
135
136 # Copy utilities from command line arguments
137
138 echo -n "Setup chroot"
139 mkchroot tmpdir4chroot $*
140 echo
141
142 mknod tmpdir4chroot/dev/tty c 5 0
143 mknod tmpdir4chroot/dev/null c 1 3
144 mknod tmpdir4chroot/dev/zero c 1 5
145
146 # Copy script from stdin
147
148 cat > tmpdir4chroot/test.sh
149 chmod +x tmpdir4chroot/test.sh
150 chroot tmpdir4chroot /test.sh
151 umount -l tmpdir4chroot
152 rmdir tmpdir4chroot
153}
154